#ifndef GF_BOUNDING_BOX_H
#define GF_BOUNDING_BOX_H

#include "gfprimtv.h"

class GFBoundingBox: public GFPrimitive {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A shadable bounding box
    // used for feedback purposes.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES: Only visible
    // in shading mode. This primitive is not
    // designed for usage via external API.
    // Therefore some methods are empty.
    // CONSTANTS: 
  public:
    GFBoundingBox(void);
    virtual ~GFBoundingBox(void);
    
    virtual void shade(void);
    void setBounds(const GBounds3&);
    void unsetBounds(void);

    virtual bool isA(const GString &) const { return(false); }
    virtual const char *getDescription(void) const { return(0); }
    virtual const char *getClass(void) const { return(0); }

    virtual void saveConstr(ostream&) {}
  private:
    GShadablePolyline* mLine1;
    GShadablePolyline* mLine2;
};

#endif
