#ifndef GF_ELLIPSOID_H
#define GF_ELLIPSOID_H

#include "gfprimtv.h"

extern const GString gfEllipsoidID;

class GFEllipsoid: public GFPrimitive {
  public:
    GFEllipsoid(const char*, const GVector3&, GFPrimitive* = (GFPrimitive*)gfNoFather);
    GFEllipsoid(const char*, const GFEllipsoid*, GFPrimitive* = (GFPrimitive*)gfNoFather);
    virtual ~GFEllipsoid(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfEllipsoidID);
    }

    virtual const char* getDescription(void) const { return("Ellipsoid. The ellipsoid is created around the local origin. Dimensions may be changed after creation."); }
    virtual const char* getClass(void) const { return(gfEllipsoidID); }

    void setDimensions(const GVector3&);
    const GVector3 getDimensions(void) const;

    virtual void saveConstr(ostream&);
#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
  private:
    virtual GFRenderable* getRenderable(void);
    class GFSphereP* mSphere;
    GVector3 mDimensions;
    virtual void resolutionChanged(void);
};

#endif
