#ifndef GF_FRAME_H
#define GF_FRAME_H

#include "gfprimtv.h"

extern const GString gfFrameID;

class GFFrame: public GFPrimitive {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A frame primitive.
    //
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFFrame(const char*, const GVector3&, GFloat, GFPrimitive* = (GFPrimitive*)gfNoFather);
    GFFrame(const char*, const GFFrame*, GFPrimitive* = (GFPrimitive*)gfNoFather);
    virtual ~GFFrame(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfFrameID);
    }

    virtual const char* getDescription(void) const { return("An orthogonal frame in x-y plane."); }
    virtual const char* getClass(void) const { return(gfFrameID); }

    virtual void saveConstr(ostream&);

    const GVector3& getDimensions(void);
    GFloat getWidth(void);
#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
  private:
    virtual GFRenderable* getRenderable(void);
    class GFFrameP* mFrame;
};

#endif
