#ifndef GF_LOCATOR_H
#define GF_LOCATOR_H

#include <input/gdevice.h>
#include "gfprimtv.h"
#include "gftypes.h"
#include "gflookat.h"

class GFLocator: public GInputDevice {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A locator will be triggered
    // by a mouse motion event w/ pressed middle or
    // right button.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES: The camera viewpoint and ref point
    // may not change.
    // CONSTANTS: 
  public:
   GFLocator(GFLookatCamera& pRend, GInputDevice* pFather = (GInputDevice*)gNoInputDevice): GInputDevice(pFather), mRend(pRend), mOldX(-1), mDiff(0.0, 0.0, 0.0), mAngle(0), mUpdate(false) {}

   void setPosition(const GPoint3&);
   
   const GVector3& getTranslation(void) const {
       return(mDiff);
   }

   GFloat getAngle(void) const {
       return(mAngle);
   }

   virtual bool event(GEvent*);
 private:
   GFLookatCamera& mRend;
   GFloat mOldX;
   GVector3 mDiff;
   GFloat mAngle;
   bool mUpdate;

   bool mNewPos; 
   GPoint3 mOldPos;

   GFloat mDist;
};

#endif
