#ifndef GF_MOVER_H
#define GF_MOVER_H

#include <input/gdevice.h>
#include "gflookat.h"

class GFMover: public GInputDevice {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: An input class for
    // VR-like moving in the scene.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFMover(GFLookatCamera&, GInputDevice* = (GInputDevice*)gNoInputDevice); 

    virtual bool event(GEvent*);
  private:
    void setupPosition(void);
  private:
    GFloat oldx, oldy;
    GFLookatCamera& mCamera;
    GFloat mAngle;
    GVector3 mPosition;
    bool mUpdate;
};

#endif
