#ifndef GF_OFF_POLYGON_H
#define GF_OFF_POLYGON_H

#include "gfprimtv.h"

extern const GString gfOffPolygonID;

class GFOffPolygon: public GFPrimitive {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A primitive encapsulating OFF 
    // polygon data sets.
    //
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFOffPolygon(const char*, const GString&, GFPrimitive* = (GFPrimitive*)gfNoFather);
    GFOffPolygon(const char*, const GFOffPolygon*, GFPrimitive* = (GFPrimitive*)gfNoFather);
    virtual ~GFOffPolygon(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfOffPolygonID);
    }

    virtual const char* getDescription(void) const { return("Polygon set representing Object File Format (OFF) data sets."); }
    virtual const char* getClass(void) const { return(gfOffPolygonID); }

    virtual void saveConstr(ostream&);

    // set/get a scaling factor:
    void setScale(GFloat);
    GFloat getScale(void) const { return(mScale); }

    const GString& getName(void);

    // overloaded ray-tracing interface:
    virtual const GSurface& getSurface(const GPoint3&);

#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
  private:
    virtual GFRenderable* getRenderable(void);
    class GFOffPolygonP* mOffPolygon;
    GFloat mScale;
};

#endif
