#ifndef GF_PICK_H
#define GF_PICK_H

#include <input/gdevice.h>
#include "gfprimtv.h"
#include "gftypes.h"
#include "gflookat.h"

class GFPick: public GInputDevice {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A selection class
    // that handles GF-specific pick style
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
   GFPick(GFLookatCamera& pRend, GInputDevice* pFather = (GInputDevice*)gNoInputDevice): GInputDevice(pFather), mPrimitive(0), mRend(pRend) {}

   const GTime& getRelativeTime(void) const {
       return(mDiffTime);
   }

   GFPrimitive* getSelection(void) const {
       return(mPrimitive);
   }
   
   virtual bool event(GEvent*);
  private:
   GTime mDiffTime;
   GFPrimitive* mPrimitive;
   GFLookatCamera& mRend;
};

#endif
