#ifndef GF_PIXMAP_H
#define GF_PIXMAP_H

#ifdef GWITH_TCL
#include "util/gtcl.h"
#endif

#include "render/gpixmap.h"
#include "util/gtempl.h"

extern const GString gfPixmapID;

class GFPixmap: public GPixmapDisplay
#ifdef GWITH_TCL
, public GTclInterface
#endif
{
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: The pixmap to render in.
    //
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFPixmap(const char*, int, int);
    virtual ~GFPixmap(void);

    const char* getDescription(void) const {
	return("A pixel-oriented output device.");
    }
  public:
    // return specified pixmap or zero:
    static GFPixmap* getByName(const char*);
    const GString& getName(void) const {
	return(mName);
    }

#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
  private:
    GString mName;
    static GDLList<GFPixmap> sList; 
};

#endif
