#ifndef GF_SPHERE_H
#define GF_SPHERE_H

#include "gfprimtv.h"

extern const GString gfSphereID;

class GFSphere: public GFPrimitive {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: An ideal sphere specified by
    // a radius. The discretiziation in object space
    // may be specified arbitraryly and will multiple
    // be used.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFSphere(const char*, GFloat, GFPrimitive* = (GFPrimitive*)gfNoFather);
    GFSphere(const char*, const GFSphere*, GFPrimitive* = (GFPrimitive*)gfNoFather);
    virtual ~GFSphere(void);

    virtual bool isA(const GString& pString) const {
	return(pString == gfSphereID);
    }

    virtual const char* getDescription(void) const { return("Sphere. The sphere is centered around the origin. The radius may be changed after creation."); }
    virtual const char* getClass(void) const { return(gfSphereID); }

    virtual void saveConstr(ostream&);

    void setRadius(GFloat);
    GFloat getRadius(void) const;
#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
  private:
    virtual GFRenderable* getRenderable(void);
    
    virtual void resolutionChanged(void);
    GFloat mRadius;
    class GFSphereP* mSphere;
};

#endif
