#ifndef GF_TOP_H
#define GF_TOP_H

#include "gfprimtv.h"

extern const GString gfTopID;

class GFTop: public GFPrimitive {
    // CONCEPT: Furniture graphics kernel
    //
    // ABSTRACT PURPOSE: A primitive representing
    // a whole furniture object. It may be translated
    // and rotated.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GFTop(const char* pName, GFPrimitive* pFather = (GFPrimitive*)gfNoFather): GFPrimitive(pName, pFather) {
	setSelectionMode(GF_SELECTABLE);
    }
    
    virtual bool isA(const GString& pString) const {
	return(pString == gfTopID);
    }

    void notSelectable(void) {
	setSelectionMode(GF_SELECT_FATHER);
    }

    virtual void saveConstr(ostream&); 
    virtual void saveChildren(ostream&); 
    
    virtual const char* getDescription(void) const { return("Invisible node for trees of primitives. May be rotated around y axis."); }
    virtual const char* getClass(void) const { return(gfTopID); }

    // accumulating local rotation around y axis:
    void rotate(const GFloat);  
    
#ifdef GWITH_TCL
  public:
    static int classCMD(ClientData, Tcl_Interp*, int, char*[]);
    virtual bool objectCMD(char*[]);
#endif
};

#endif
