#ifndef __GT_BSP_H__
#define __GT_BSP_H__

#include "gt_bbox.h"

enum   {
    X_AXIS,
      Y_AXIS,
      Z_AXIS
};

class GT_BSP_Node;
 
class GT_BSP_Node : public GTBBox  {
 public:
    GT_BSP_Node*     mChild[2];
    int              mAxis;
    GFloat           mPlane;
    
    GT_BSP_Node(void) {
	mChild[0] = mChild[1] = 0;
    }
    virtual         ~GT_BSP_Node(void);
    void             classify(const GRay3&    pRay,
			      GFloat&         rDist,
			      GT_BSP_Node*&   rNear,
			      GT_BSP_Node*&   rFar);
   
};
 
class GT_BSP_Tree  {
 public:
   GT_BSP_Tree(GTScene* sc) ;
   virtual ~GT_BSP_Tree(void);
   
   bool   intersect(GRay3& rRay, GInterSectionList& rInter);
   void   buildHierarchy(void);

 private:
    int             mMaxDepth;	   
    int             mMaxListLength;
    GT_BSP_Node*    mRoot;
    GTObjectList    mListObjects;
};

#endif 
