#ifndef __GT_CAMERA_H__
#define __GT_CAMERA_H__

#include "render/graycam.h"
#include "render/gpixmap.h"

#include "gt_bsp.h"
#include "gt_shade.h"

class GTRayTracer: public GLookatRayTracer<GTObject, GPixmapDisplay> {
    // CONCEPT: Derived test graphics kernel
    //
    // ABSTRACT PURPOSE: A raytracer w/ BSP and ABVH acceleration
    //
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 

 public:
    
    GTRayTracer(void)
      : GLookatRayTracer<GTObject, GPixmapDisplay>(),
      mBSP_Tree(0) {}
    
    virtual ~GTRayTracer(void);
    
    virtual void rendering(GTScene *pScene);

    GColorRGB traceShadingRay(int       LEVEL, 
			      GFloat    WEIGHT, 
			      GRay3&    rWC_RAY);
   
    GColorRGB traceShadowRay(GRay3&          rWC_RAY,
			     GRayTraceable*  rLastOpaque);
   
   
    GColorRGB trace(int    LEVEL, 
		    GFloat WEIGHT, 
		    GRay3& rWC_RAY);

    GColorRGB shade(int    LEVEL, 
		    GFloat WEIGHT, 
		    GRay3& rWC_RAY, 
		    const GInterSection& pInter);


 private:
   GT_BSP_Tree*    mBSP_Tree;
   GTLightList     mListLights;
};

#endif
