#define MAXFLT  1e+20

// absolute value of a 
#define GTM_ABS(a)		(((a)<0) ? -(a) : (a))

// round a to nearest int 
#define GTM_ROUND(a)	floor((a)+0.5)

// take sign of a, either -1, 0, or 1 
#define GTM_ZSGN(a)		(((a)<0) ? -1 : (a)>0 ? 1 : 0)

// take binary sign of a, either -1, or 1 if >= 0 
#define GTM_SGN(a)		(((a)<0) ? -1 : 1)

// square a 
#define GTM_SQRT(a)		((a)*(a))

// find minimum of a and b 
#define GTM_MIN(a,b)	(((a)<(b))?(a):(b))

// find maximum of a and b 
#define GTM_MAX(a,b)	(((a)>(b))?(a):(b))

// swap a and b (see Gem by Wyvill) 
#define GTM_MASK_SWAP(a,b)	{ a^=b; b^=a; a^=b; }

// From Ron Guillmette; apparently needed for Hansens code 
#define GTM_SWAP(a,b) ({ typeof(a) temp = (a); (a) = (b); (b) = temp; })


// linear interpolation from l (when a=0) to h (when a=1)
// (equal to (a*h)+((1-a)*l) 
#define GTM_LERP(a,l,h)	((l)+(((h)-(l))*(a)))

// clamp the input to the specified range 
#define GTM_CLAMP(v,l,h)	((v)<(l) ? (l) : (v) > (h) ? (h) : v)

#ifndef KILL_MEM
#define KILL_MEM(x) if((x)){ delete (x); (x) = NULL;}
#endif

#ifndef KILL_ARR
#define KILL_ARR(x) if((x)){ delete [] (x); (x) = NULL;}
#endif

//// some constants
#ifndef M_PI
#define M_PI		3.141592	/* the venerable pi */
#endif
#ifndef M_E
#define M_E		2.718282	/* the venerable e */
#endif
#ifndef M_PITIMES2
#define M_PITIMES2	6.283185	/* 2 * pi */
#endif
#ifndef M_PIOVER2
#define M_PIOVER2	1.570796	/* pi / 2 */
#endif
#ifndef M_SQRT2
#define M_SQRT2		1.414214	/* sqrt(2) */
#endif
#ifndef M_SQRT3
#define M_SQRT3		1.732051	/* sqrt(3) */
#endif
#ifndef M_GOLDEN
#define M_GOLDEN	1.618034	/* the golden ratio */
#endif
#ifndef M_D2R
#define M_D2R		0.017453	/* convert degrees to radians */
#endif
#ifndef M_R2D
#define M_R2D		57.29578	/* convert radians to degrees */
#endif

#ifndef TRUE
#define TRUE		1
#define FALSE		0
#endif
    
#ifndef ON
#define ON		1
#define OFF		0


    
#ifndef KILL_MEM
#define KILL_MEM(x) if((x)){ delete (x); (x) = 0;}
#endif

#ifndef KILL_ARR
#define KILL_ARR(x) if((x)){ delete [] (x); (x) = 0;}
#endif
    

#ifdef GTD_DEBUG
#define CHECK(cond, msg) if((cond)){ cerr << (msg) << "!\n"; exit(2);}
#define STAT(action) {(action);}
#else
#define CHECK(cond, msg)  ;;;
#define STAT(action) ;;;
#endif




#endif


