#ifndef G_GRAPHICAL_DATA_H
#define G_GRAPHICAL_DATA_H

#include "ggeneric.h"
#include "gstorabl.h"

class GGraphicalData: public GStorable {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: Basic class for
    // multiple referenceable graphical data.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  protected:
    GGraphicalData(): mRefCnt(0) {}
  public:
    void ref(void) { mRefCnt++; }
    bool deref(void) {
	// return true if object may be deleted 
	assert(mRefCnt);
	return(--mRefCnt ? false : true);
    }
  private:
    int mRefCnt;
};

#endif
