#ifndef G_ERROR_H
#define G_ERROR_H

#include <stdarg.h>
#include "util/gstring.h"

class GOutput {
  public:
    GOutput(): prog("gene") {}
    
    virtual void special(const char*) = 0;
    virtual void specialVar(const char* ...) = 0;
    // special messages will not presented 
    // to the standard user
    // they can be used for log files etc.

    virtual void message(const char*) = 0;
    virtual void messageVar(const char* ...) = 0;

    virtual void warning(const char*) = 0;
    virtual void warningVar(const char* ...) = 0;

    virtual void error(const char*) = 0;
    virtual void errorVar(const char* ...) = 0;

    // a fatal error leads to the exit
    virtual void fatal(const char*) = 0;
    virtual void fatalVar(const char* ...) = 0;
  protected:
    GString prog;
};

class GSystemOutput: public GOutput {
  public:
    void special(const char*) {}
    void specialVar(const char* ...) {}

    void message(const char*);
    void messageVar(const char* ...);

    void warning(const char*);
    void warningVar(const char* ...);
    
    void error(const char*);
    void errorVar(const char*...);

    void fatal(const char*);
    void fatalVar(const char*...);
};

extern GOutput* gOutput;

#endif
