#ifndef G_SERVER_H
#define G_SERVER_H

#include "input/gdevice.h"

class GInputServer {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: A server containing all
    // father-less input objects.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GInputServer(void): mIDList(true) {}

    void add(GInputDevice* pDevice) {
	mIDList.append(pDevice);
    }
    void remove(GInputDevice* pDevice) {
	mIDList.remove(pDevice);
    }
    // non-blocking iteration about all input objects:
    void event(void);
  private:
    GDLList<GInputDevice> mIDList;
};

extern GInputServer gInputServer;

// endless input polling loop:
void gInputLoop(void);

#endif
