#ifndef G_TIME_H
#define G_TIME_H

#include "ggeneric.h"

class GTime {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: Represenation of time
    // in seconds and micro seconds after Jan. 1st 1970
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
    friend ostream& operator<<(ostream&, const GTime&);
    friend GTime operator-(const GTime&, const GTime&);
    friend bool operator<(const GTime&, const GTime&);
    friend bool operator>(const GTime&, const GTime&);
  public:
    GTime(void);
    long getSeconds(void) const { 
	return(mSeconds); 
    }
    long getMicroSeconds(void) const { 
	return(mMicroSeconds); 
    }

    static GTime getTime(void) { 
	GTime tTime;
	return(tTime);
    } 
  private:
    long mSeconds; 
    long mMicroSeconds;
};

#endif
