#ifndef GTIMER_H
#define GTIMER_H

#include "input/gdevice.h"
#include "input/gtime.h"

class GTimer: public GInputDevice, GTime {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: The following class
    // is implemented to call the call backs
    // after a time delay until the timer 
    // is stopped.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GTimer(GFloat pInterval): GInputDevice((GInputDevice*)gNoInputDevice), mInterval(pInterval) {}

    virtual bool event(GEvent* = 0);

    GFloat getInterval(void) const {
        return(mInterval);
    }
    void setInterval(GFloat pInterval) {
        mInterval = pInterval;
    }
  private:
    GFloat mInterval;
    GTime mTime;
};

#endif
