#ifndef G_UPDATE_H
#define G_UPDATE_H

#include "input/gdevice.h"
#include "render/gpixmap.h"

class GUpdatePixmap: public GInputDevice {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: A device that is triggered
    // after an update request for a pixmap.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GUpdatePixmap(GPixmapDisplay& pDisp, GInputDevice* pFather = (GInputDevice*)gNoInputDevice): GInputDevice(pFather), mDisp(pDisp) {}

    GPixmapDisplay& getPixmapDisplay(void) const {
	return(mDisp);
    }

    virtual bool event(GEvent* pEvent) {
	bool ret = false;
	if (pEvent && pEvent->isA(gPixmapUpdateEventID)) {
	    if (((GUpdatePixmapEvent*)pEvent)->pixmap == &mDisp) {
		callCBs();
		ret = true;
	    }
	}
	GInputDevice::event(pEvent);
	return(ret);
    }
  private:
    GPixmapDisplay& mDisp;
};

#endif
