#ifndef G_PIXMAP_H
#define G_PIXMAP_H

#include "render/grealiz.h"
#include "util/gstring.h"
#include "util/gcolor.h"

class GPixmapDisplayData;
// DEFINED AND IMPLEMENTED PLATFORM DEPENDENT

class GPixmapDisplay: public GRealization {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: Concrete realization class
    // for rectangular pixel-based output.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
    friend class GPixmapDisplayData;
  public:
    GPixmapDisplay(const GString&, int, int);
    // IMPLEMENTED PLATFORM DEPENDENT
    virtual ~GPixmapDisplay(void);
    // IMPLEMENTED PLATFORM DEPENDENT
    void putPixel(int, int, const GColorRGB&);
    // (0,0) is the lower left corner
    // IMPLEMENTED PLATFORM DEPENDENT
    void clear(const GColorRGB&);
    // IMPLEMENTED PLATFORM DEPENDENT
    virtual void activate();
    // IMPLEMENTED PLATFORM DEPENDENT

    int getWidth(void) const { return(mWidth); }
    int getHeight(void) const { return(mHeight); }
    bool inSingleBufferMode(void) const { return(mSglBuf); }

    GPixmapDisplayData& getData(void) { return(*mData); }

    virtual GEvent* getEvent(void);
    // IMPLEMENTED PLATFORM DEPENDENT

    virtual void swapBuffers(void);
    // IMPLEMENTED PLATFORM DEPENDENT
  private:
    int mWidth, mHeight;
    bool mSglBuf;
    GPixmapDisplayData* mData;
};

#endif
