#ifndef G_REALIZATION_H
#define G_REALIZATION_H

class GEvent;

class GRealization {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: Abstract base class of all
    // objects to render in.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    // Non-blocking event polling.
    // A dynamically created event will be returned or 0.
    // The event has to be deleted by the caller.
    virtual GEvent* getEvent(void) { return(0); }
    // activate the realization:
    virtual void activate(void) {}
};

#endif 
