#ifndef GHEAP_H
#define GHEAP_H

template<class T>
class GHeap {  
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: Parametric heap
    // implementation.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:  
    GHeap(int pSize=2);  
    ~GHeap(void);  
    
    void     insert(const T& x);  
    T        remove(void);  
    void     reset(void);  
    int      count(void) const;  
    
 private:  
    T*       mItems;  
    int      mNumber;  
    int      mSize;  
    
    void     upHeap(int i);  
    void     downHeap(int i);  
};  
 
template<class T> 
inline GHeap<T>::GHeap(int pSize)  {  
    mItems  = new T[pSize];  
    mNumber = 0;  
    mSize   = pSize;  
}  

template<class T>
inline GHeap<T>::~GHeap()  {  
    delete[] mItems;  
}  
 
template<class T> 
inline void GHeap<T>::insert(const T& pItem)  {  
    if (++mNumber >= mSize)   {  
        T *temp = new T[mSize <<= 1];  
        for (register int i = 0; i < mNumber-1; i++)  
          temp[i] = mItems[i];  
        delete[] mItems;  
        mItems = temp;  
    }  
    mItems[n-1] = pItem;  
    upHeap(n-1);  
}  
 
template<class T>
inline T GHeap<T>::remove(void)  {  
    T ret = mItems[0];  
    if (--mNumber > 0)   {  
        mItems[0] = mItems[n];  
        downHeap(0);  
    }  
    return(ret);  
}  

template<class T>
inline void  GHeap<T>::reset(void)  {  
    mNumber = 0;  
}  
 
template<class T> 
inline int GHeap<T>::count(void) const  {  
    return(mNumber);  
}  
 
template<class T>
inline void  GHeap<T>::upHeap(int i)  {  
    int p;  
    T temp = mItems[i];  
    
    while (i)   {  
        p = (i-1) >> 1;  
        if ( mItems[p] < temp )  
          break;  
        mItems[i] = mItems[p];  
        i = p;  
    }  
    mItems[i] = temp;  
}  
 
template<class T>
inline void GHeap::downHeap(int i)  {  
    int c;  
    T temp = mItems[i];  
    
    while((c = ((i<<1)+1)) < mNumber)   {  
        if (c+1 < mNumber)  
          c += (mItems[c+1] < mItems[c]) ;  
        if (temp < mItems[c] )  
          break;  
        mItems[i] = mItems[c];  
        i = c;  
    }  
    mItems[i] = temp;  
}

#endif
