#ifndef G_IDENTIFICATION_H
#define G_IDENTIFICATION_H

#include "util/gstring.h"
#include "util/gtempl.h"
#include "goutput.h"

class GIdentification {
    // CONCEPT: Generic graphics kernel
    //
    // ABSTRACT PURPOSE: An identification consists of an ASCII name.
    // Further semantics may be expressed in derived classes, e.g.
    // support for hierarchies.
    // INVARIANT:
    //
    // IMPLEMENTATION ISSUES:
    //
    // CONSTANTS: 
  public:
    GIdentification(const char* = 0);
    // CTOR: Constructing an identification from a string.

    virtual ~GIdentification(void);
    // DTOR: Virtual destructor.

    const GString& getIdentification(void) const;
    // METHOD: Return identification as string.

    const GString& getName(void) const {
	return(getIdentification());
    }
    // METHOD: Return identification as string.
  public:
    static bool identificationExist(const char*);
    // METHOD: Return truen if the passed string already
    // exists for an object.
    static GIdentification* getObjectByIdentification(const char*);
    // METHOD: Return the related object or zero.
  private:
    // a dynamically-associated string:
    GString* mName;
    // the static storage of all identification
    // objects (i.e. mName != 0):
    static GDLList<GIdentification> sList;
};

#endif
