//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel. Copying, distribution and     
//  legal info is in the file COPYRIGHT which should be distributed with this 
//  file. If COPYRGHT is not available or for more info please contact: 
//		ekki@prakinf.tu-ilmenau.de
/////////// (C) '95 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "goutput.h"

#include <stdlib.h>
#include <stdarg.h>

void GSystemOutput::message(const char *s) {
    fprintf(stderr, "%s message: %s\n ", (char*)prog, s);
}

void GSystemOutput::messageVar(const char *s ...) {
    fprintf(stderr, "%s message: %s", (char*)prog, s);
    va_list args;
    va_start(args, s);
    while (s = va_arg(args, char*)) fputs(s, stderr);
    fputc('\n', stderr);
    va_end(args);
}

void GSystemOutput::warning(const char *s) {
    fprintf(stderr, "%s warning: %s\n ", (char*)prog, s);
}

void GSystemOutput::warningVar(const char *s ...) {
    fprintf(stderr, "%s warning: %s", (char*)prog, s);
    va_list args;
    va_start(args, s);
    while (s = va_arg(args, char*)) fputs(s, stderr);
    fputc('\n', stderr);
    va_end(args);
}

void GSystemOutput::error(const char *s) {
    fprintf(stderr, "%s error: %s\n ", (char*)prog, s);
}

void GSystemOutput::errorVar(const char *s ...) {
    fprintf(stderr, "%s error: %s", (char*)prog, s);
    va_list args;
    va_start(args, s);
    while (s = va_arg(args, char*)) fputs(s, stderr);
    fputc('\n', stderr);
    va_end(args);
}

void GSystemOutput::fatal(const char *s) {
    fprintf(stderr, "%s fatal error: %s\n ", (char*)prog, s);
    exit(1);
}

void GSystemOutput::fatalVar(const char *s ...) {
    fprintf(stderr, "%s fatal error: %s", (char*)prog, s);
    va_list args;
    va_start(args, s);
    while (s = va_arg(args, char*)) fputs(s, stderr);
    fputc('\n', stderr);
    va_end(args);
    exit(1);
}

GOutput* gOutput = new GSystemOutput;

