//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel. Copying, distribution and     
//  legal info is in the file COPYRIGHT which should be distributed with this 
//  file. If COPYRGHT is not available or for more info please contact: 
//		ekki@prakinf.tu-ilmenau.de
/////////// (C) '95 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#ifdef GWITH_TCL

#include <math.h>
#include "util/gtclpars.h"
#include "util/gtclmath.h"

double exp10(GFloat x) {
    return(exp(x*log(10)));
}

typedef double (*gMathFunc)(double);

static int gTclMathCMD(ClientData cd, Tcl_Interp *ip, int argc, char *argv[]) {
    GFloat ret, val;
    if (argc != 2) {
        Tcl_AppendResult(ip,argv[0],": wrong # args: should be \"",
                         argv[0]," <float>!\"", 0);
        return(TCL_ERROR);
    }
    if (!(gTclString2Float(argv[1], val))) {
        Tcl_AppendResult(ip, argv[0], ": wrong arg #1: should be a float!", 0);
        return(TCL_ERROR); 
    } 
    ret = ((gMathFunc)cd)(val);
    
    Tcl_AppendResult(ip, gTclFloat2String(ret), 0);
    return(TCL_OK);
}

void gTclMathInit(Tcl_Interp* ip) {
    Tcl_CreateCommand(ip, "acos", gTclMathCMD, (ClientData)acos, 0);
    Tcl_CreateCommand(ip, "acosh", gTclMathCMD, (ClientData)acosh, 0);
    Tcl_CreateCommand(ip, "asin", gTclMathCMD, (ClientData)asin, 0);
    Tcl_CreateCommand(ip, "asinh", gTclMathCMD, (ClientData)asinh, 0);
    Tcl_CreateCommand(ip, "atan", gTclMathCMD, (ClientData)atan, 0);
    Tcl_CreateCommand(ip, "atanh", gTclMathCMD, (ClientData)atanh, 0);
    Tcl_CreateCommand(ip, "cos", gTclMathCMD, (ClientData)cos, 0);
    Tcl_CreateCommand(ip, "cosh", gTclMathCMD, (ClientData)cosh, 0);
    Tcl_CreateCommand(ip, "exp", gTclMathCMD, (ClientData)exp, 0);
    Tcl_CreateCommand(ip, "exp10", gTclMathCMD, (ClientData)exp10, 0);
    Tcl_CreateCommand(ip, "log", gTclMathCMD, (ClientData)log, 0);
    Tcl_CreateCommand(ip, "log10", gTclMathCMD, (ClientData)log10, 0);
    Tcl_CreateCommand(ip, "sin", gTclMathCMD, (ClientData)sin, 0);
    Tcl_CreateCommand(ip, "sinh", gTclMathCMD, (ClientData)sinh, 0);
    Tcl_CreateCommand(ip, "sqrt", gTclMathCMD, (ClientData)sqrt, 0);
    Tcl_CreateCommand(ip, "tan", gTclMathCMD, (ClientData)tan, 0);
    Tcl_CreateCommand(ip, "tanh", gTclMathCMD, (ClientData)tanh, 0);
}

#endif
