//////////////////////////////////////////////////////////////////////////////
//  This file belongs to the GENERIC 3D kernel. Copying, distribution and     
//  legal info is in the file COPYRIGHT which should be distributed with this 
//  file. If COPYRGHT is not available or for more info please contact: 
//		ekki@prakinf.tu-ilmenau.de
/////////// (C) '95 Ekkehard 'Ekki' Beier - All rights reserved. /////////////
#include "util/gvector.h"

bool GVector2::operator==(const GVector2& v) const {
    if (mX != v.mX) return(false);
    if (mY != v.mY) return(false);
    return(true);
}

ostream& operator<<(ostream& pStream, const GVector2& pVector) {
    pStream << '{' << pVector.mX << ' ' << pVector.mY << '}';
    return(pStream);
}

bool GVector3::operator==(const GVector3& v) const {
    if (mX != v.mX) return(false);
    if (mY != v.mY) return(false);
    if (mZ != v.mZ) return(false);
    return(true);
}

ostream& operator<<(ostream& pStream, const GVector3& pVector) {
    pStream << '{' << pVector.mX << ' ' << pVector.mY << ' ' << pVector.mZ << '}';
    return(pStream);
}

ostream& operator<<(ostream& pStream, const GRay3& pRay) {
    pStream << '{' << pRay.mPoint << " + " << pRay.mLength << " * " << pRay.mVector << '}';
    return(pStream);
}

ostream& operator<<(ostream& pStream, const GBounds3& pBounds) {
    pStream << '{' << pBounds.mMin << "  " << pBounds.mMax << '}';
    return(pStream);
}

const GPoint3 gOrigin3(0.0, 0.0, 0.0);
